#include "histogram.h"
using namespace std;
void find_minmax(const vector<double>& numbers, double& min, double& max) {
    if (numbers.size() == 0) return;
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
}
vector<double> make_histogram(const vector<double>& numbers, size_t bin_count)
{
    vector <double> bins;
    double min, max;
    find_minmax(numbers, min, max);
    int number_count = numbers.size();
    bins.resize(bin_count);
    double bin_size = (max - min) / bin_count;
    for (int i = 0; i < number_count; i++)
    {
        bool found = false;
        for (int j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }

        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}