#include <iostream>
#include <vector>
#include <string>

using namespace std;
void svg_begin(double width, double height) {
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}
void svg_text(double left, double baseline, string text) {
    cout << "<text x='" << left << "' y='" << baseline<< "'>" << text << "</text>" << endl;
}
void svg_end() {
    cout << "</svg>\n";
}
void svg_rect(double x, double y, double width, double height,string stroke = "black", string fill = "green")
{
    cout << "<rect x='" << x << "' y='" << y << "' width='" << width << "' height='" << height << "' fill='" << fill << "' stroke='" << stroke << "' />";
}
int GetProc(int number_cnt, int bin)
{
    if (number_cnt <= 0) return 0;
    if (bin < 0) return 0;
    return 100.0 * bin / number_cnt;
}

void show_histogram_svg(const vector<double>& bins, int number_cnt) {
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    string colors[]{ "#0000ff", "#00ff00", "#ff0000", "#00ffff", "#ff00ff", "#ffff00", "#ffffff", "#aaaaaa" };
    svg_begin(400, 300);
    double top = 0;
    int color_ptr=7;
    double max = bins[0];
    for (size_t bin : bins) if (bin > max) max = bin;
    cout << max;
    //double k = (IMAGE_WIDTH - TEXT_WIDTH*2) / max;
    double k = (IMAGE_WIDTH - TEXT_WIDTH) / max;
    for (size_t bin : bins) {
        const double bin_width = k * bin;
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, to_string(bin));
        //svg_text(IMAGE_WIDTH - TEXT_WIDTH + TEXT_LEFT, top + TEXT_BASELINE, to_string(GetProc(number_cnt,bin)) + "%");
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT,"black",colors[color_ptr]);
        top += BIN_HEIGHT;
        color_ptr++;
        std::cout << endl << "colors->size() = " << colors->size() << endl;
        if (color_ptr > (colors->size()-1)) color_ptr = 0;
    }
    svg_end();

}

